-- Do not edit.  Generated by cheby 1.6.dev0 using these options:
--  --gen-hdl vme_regs_map.vhd -i vme_regs_map.cheby
-- Generated on Wed Jan 24 10:41:46 2024 by tgingold


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity vme_regs_map is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_cyc_i             : in    std_logic;
    wb_stb_i             : in    std_logic;
    wb_adr_i             : in    std_logic_vector(9 downto 2);
    wb_sel_i             : in    std_logic_vector(3 downto 0);
    wb_we_i              : in    std_logic;
    wb_dat_i             : in    std_logic_vector(31 downto 0);
    wb_ack_o             : out   std_logic;
    wb_err_o             : out   std_logic;
    wb_rty_o             : out   std_logic;
    wb_stall_o           : out   std_logic;
    wb_dat_o             : out   std_logic_vector(31 downto 0);

    -- HW version
    version_i            : in    std_logic_vector(31 downto 0);

    -- Interrupt Id
    intid_val_o          : out   std_logic_vector(7 downto 0);

    -- Interrupts status
    -- AC fail status from VME bus
    istat_acfail_i       : in    std_logic;
    istat_acfail_o       : out   std_logic;
    istat_irq_i          : in    std_logic_vector(6 downto 0);
    istat_irq_o          : out   std_logic_vector(6 downto 0);

    -- Interrupts mask
    imask_acfail_o       : out   std_logic;
    imask_irq_o          : out   std_logic_vector(6 downto 0);

    -- Control register
    -- Enable a RMW cycle
    mstr_rmwena_i        : in    std_logic;
    mstr_rmwena_o        : out   std_logic;
    -- Release bus when done
    mstr_req_o           : out   std_logic;
    -- Bus error detected
    mstr_berr_i          : in    std_logic;
    mstr_berr_o          : out   std_logic;
    -- Bus error interrupt enable
    mstr_iberr_o         : out   std_logic;
    -- Posted Write (unused)
    mstr_postwr_o        : out   std_logic;
    -- Address Only cycle
    mstr_ado_i           : in    std_logic;
    mstr_ado_o           : out   std_logic;
    -- Fair Requests
    mstr_fairreq_o       : out   std_logic;
    -- AM for A16
    mstr_A16_mode_o      : out   std_logic_vector(1 downto 0);
    -- AM for A24
    mstr_A24_mode_o      : out   std_logic_vector(1 downto 0);
    -- AM for A32
    mstr_A32_mode_o      : out   std_logic_vector(1 downto 0);
    mstr_wr_o            : out   std_logic;

    -- System Control register
    -- System Controler (slot 1)
    sysc_sysc_i          : in    std_logic;
    sysc_sysc_o          : out   std_logic;
    -- System Reset
    sysc_sysr_i          : in    std_logic;
    sysc_sysr_o          : out   std_logic;
    -- Arbitrer timeout
    sysc_ato_i           : in    std_logic;
    sysc_wr_o            : out   std_logic;

    -- Upper address bits for A32
    -- Upper 8 bits
    longadd_val_o        : out   std_logic_vector(7 downto 0);

    -- DMA status
    -- Start DMA
    dmasta_en_i          : in    std_logic;
    dmasta_en_o          : out   std_logic;
    -- Enable DMA interrupt
    dmasta_ien_o         : out   std_logic;
    -- DMA interrupt
    dmasta_irq_i         : in    std_logic;
    dmasta_irq_o         : out   std_logic;
    -- DMA error
    dmasta_err_i         : in    std_logic;
    dmasta_err_o         : out   std_logic;
    -- DMA current buffer descriptor
    dmasta_bd_i          : in    std_logic_vector(3 downto 0);
    dmasta_bd_o          : out   std_logic_vector(3 downto 0);
    dmasta_wr_o          : out   std_logic;

    -- Slot and geographic address
    -- Geographic address
    slot_ga_i            : in    std_logic_vector(5 downto 0);
    -- Slot number
    slot_slot_i          : in    std_logic_vector(4 downto 0);

    -- Bus request line
    brl_val_o            : out   std_logic_vector(1 downto 0);

    -- Bus error address
    berr_addr_i          : in    std_logic_vector(31 downto 0);

    -- Extra info on berr
    -- address mode
    berr_extra_vam_i     : in    std_logic_vector(5 downto 0);
    -- access
    berr_extra_rw_i      : in    std_logic;
    -- interrup cycle
    berr_extra_iack_i    : in    std_logic;

    -- DMA buffers
    dbram_addr_o         : out   std_logic_vector(8 downto 2);
    dbram_data_i         : in    std_logic_vector(31 downto 0);
    dbram_data_o         : out   std_logic_vector(31 downto 0);
    dbram_wr_o           : out   std_logic
  );
end vme_regs_map;

architecture syn of vme_regs_map is
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal intid_val_reg                  : std_logic_vector(7 downto 0);
  signal intid_wreq                     : std_logic;
  signal intid_wack                     : std_logic;
  signal istat_acfail_reg               : std_logic;
  signal istat_wreq                     : std_logic;
  signal istat_wack                     : std_logic;
  signal imask_acfail_reg               : std_logic;
  signal imask_irq_reg                  : std_logic_vector(6 downto 0);
  signal imask_wreq                     : std_logic;
  signal imask_wack                     : std_logic;
  signal mstr_req_reg                   : std_logic;
  signal mstr_berr_reg                  : std_logic;
  signal mstr_iberr_reg                 : std_logic;
  signal mstr_postwr_reg                : std_logic;
  signal mstr_fairreq_reg               : std_logic;
  signal mstr_A16_mode_reg              : std_logic_vector(1 downto 0);
  signal mstr_A24_mode_reg              : std_logic_vector(1 downto 0);
  signal mstr_A32_mode_reg              : std_logic_vector(1 downto 0);
  signal mstr_wreq                      : std_logic;
  signal mstr_wack                      : std_logic;
  signal sysc_ato_reg                   : std_logic;
  signal sysc_wreq                      : std_logic;
  signal sysc_wack                      : std_logic;
  signal longadd_val_reg                : std_logic_vector(7 downto 0);
  signal longadd_wreq                   : std_logic;
  signal longadd_wack                   : std_logic;
  signal dmasta_ien_reg                 : std_logic;
  signal dmasta_wreq                    : std_logic;
  signal dmasta_wack                    : std_logic;
  signal brl_val_reg                    : std_logic_vector(1 downto 0);
  signal brl_wreq                       : std_logic;
  signal brl_wack                       : std_logic;
  signal dbram_rack                     : std_logic;
  signal dbram_re                       : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(9 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal dbram_wp                       : std_logic;
  signal dbram_we                       : std_logic;
begin

  -- WB decode signals
  wb_en <= wb_cyc_i and wb_stb_i;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_we_i)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_we_i) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_we_i)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_we_i) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_ack_o <= ack_int;
  wb_stall_o <= not ack_int and wb_en;
  wb_rty_o <= '0';
  wb_err_o <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wb_dat_o <= "00000000000000000000000000000000";
        wr_req_d0 <= '0';
        wr_adr_d0 <= "00000000";
        wr_dat_d0 <= "00000000000000000000000000000000";
      else
        rd_ack_int <= rd_ack_d0;
        wb_dat_o <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= wb_adr_i;
        wr_dat_d0 <= wb_dat_i;
      end if;
    end if;
  end process;

  -- Register version

  -- Register intid
  intid_val_o <= intid_val_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        intid_val_reg <= "00000000";
        intid_wack <= '0';
      else
        if intid_wreq = '1' then
          intid_val_reg <= wr_dat_d0(7 downto 0);
        end if;
        intid_wack <= intid_wreq;
      end if;
    end if;
  end process;

  -- Register istat
  istat_acfail_o <= istat_acfail_reg;
  istat_irq_o <= wr_dat_d0(7 downto 1);
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        istat_acfail_reg <= '0';
        istat_wack <= '0';
      else
        if istat_wreq = '1' then
          istat_acfail_reg <= istat_acfail_i or (istat_acfail_reg and not wr_dat_d0(0));
        else
          istat_acfail_reg <= istat_acfail_i or istat_acfail_reg;
        end if;
        istat_wack <= istat_wreq;
      end if;
    end if;
  end process;

  -- Register imask
  imask_acfail_o <= imask_acfail_reg;
  imask_irq_o <= imask_irq_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        imask_acfail_reg <= '0';
        imask_irq_reg <= "0000000";
        imask_wack <= '0';
      else
        if imask_wreq = '1' then
          imask_acfail_reg <= wr_dat_d0(0);
          imask_irq_reg <= wr_dat_d0(7 downto 1);
        end if;
        imask_wack <= imask_wreq;
      end if;
    end if;
  end process;

  -- Register mstr
  mstr_rmwena_o <= wr_dat_d0(0);
  mstr_req_o <= mstr_req_reg;
  mstr_berr_o <= mstr_berr_reg;
  mstr_iberr_o <= mstr_iberr_reg;
  mstr_postwr_o <= mstr_postwr_reg;
  mstr_ado_o <= wr_dat_d0(5);
  mstr_fairreq_o <= mstr_fairreq_reg;
  mstr_A16_mode_o <= mstr_A16_mode_reg;
  mstr_A24_mode_o <= mstr_A24_mode_reg;
  mstr_A32_mode_o <= mstr_A32_mode_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        mstr_req_reg <= '0';
        mstr_berr_reg <= '0';
        mstr_iberr_reg <= '0';
        mstr_postwr_reg <= '0';
        mstr_fairreq_reg <= '0';
        mstr_A16_mode_reg <= "00";
        mstr_A24_mode_reg <= "00";
        mstr_A32_mode_reg <= "00";
        mstr_wack <= '0';
      else
        if mstr_wreq = '1' then
          mstr_req_reg <= wr_dat_d0(1);
          mstr_berr_reg <= mstr_berr_i or (mstr_berr_reg and not wr_dat_d0(2));
          mstr_iberr_reg <= wr_dat_d0(3);
          mstr_postwr_reg <= wr_dat_d0(4);
          mstr_fairreq_reg <= wr_dat_d0(6);
          mstr_A16_mode_reg <= wr_dat_d0(9 downto 8);
          mstr_A24_mode_reg <= wr_dat_d0(11 downto 10);
          mstr_A32_mode_reg <= wr_dat_d0(13 downto 12);
        else
          mstr_berr_reg <= mstr_berr_i or mstr_berr_reg;
        end if;
        mstr_wack <= mstr_wreq;
      end if;
    end if;
  end process;
  mstr_wr_o <= mstr_wack;

  -- Register sysc
  sysc_sysc_o <= wr_dat_d0(0);
  sysc_sysr_o <= wr_dat_d0(1);
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        sysc_ato_reg <= '0';
        sysc_wack <= '0';
      else
        if sysc_wreq = '1' then
          sysc_ato_reg <= sysc_ato_i or (sysc_ato_reg and not wr_dat_d0(2));
        else
          sysc_ato_reg <= sysc_ato_i or sysc_ato_reg;
        end if;
        sysc_wack <= sysc_wreq;
      end if;
    end if;
  end process;
  sysc_wr_o <= sysc_wack;

  -- Register longadd
  longadd_val_o <= longadd_val_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        longadd_val_reg <= "00000000";
        longadd_wack <= '0';
      else
        if longadd_wreq = '1' then
          longadd_val_reg <= wr_dat_d0(7 downto 0);
        end if;
        longadd_wack <= longadd_wreq;
      end if;
    end if;
  end process;

  -- Register dmasta
  dmasta_en_o <= wr_dat_d0(0);
  dmasta_ien_o <= dmasta_ien_reg;
  dmasta_irq_o <= wr_dat_d0(2);
  dmasta_err_o <= wr_dat_d0(3);
  dmasta_bd_o <= wr_dat_d0(7 downto 4);
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        dmasta_ien_reg <= '0';
        dmasta_wack <= '0';
      else
        if dmasta_wreq = '1' then
          dmasta_ien_reg <= wr_dat_d0(1);
        end if;
        dmasta_wack <= dmasta_wreq;
      end if;
    end if;
  end process;
  dmasta_wr_o <= dmasta_wack;

  -- Register slot

  -- Register brl
  brl_val_o <= brl_val_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        brl_val_reg <= "00";
        brl_wack <= '0';
      else
        if brl_wreq = '1' then
          brl_val_reg <= wr_dat_d0(1 downto 0);
        end if;
        brl_wack <= brl_wreq;
      end if;
    end if;
  end process;

  -- Register berr_addr

  -- Register berr_extra

  -- Interface dbram
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        dbram_rack <= '0';
      else
        dbram_rack <= dbram_re and not dbram_rack;
      end if;
    end if;
  end process;
  dbram_data_o <= wr_dat_d0;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        dbram_wp <= '0';
      else
        dbram_wp <= (wr_req_d0 or dbram_wp) and rd_req_int;
      end if;
    end if;
  end process;
  dbram_we <= (wr_req_d0 or dbram_wp) and not rd_req_int;
  process (wb_adr_i, wr_adr_d0, dbram_re) begin
    if dbram_re = '1' then
      dbram_addr_o <= wb_adr_i(8 downto 2);
    else
      dbram_addr_o <= wr_adr_d0(8 downto 2);
    end if;
  end process;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, intid_wack, istat_wack, imask_wack, mstr_wack,
           sysc_wack, longadd_wack, dmasta_wack, brl_wack, dbram_we) begin
    intid_wreq <= '0';
    istat_wreq <= '0';
    imask_wreq <= '0';
    mstr_wreq <= '0';
    sysc_wreq <= '0';
    longadd_wreq <= '0';
    dmasta_wreq <= '0';
    brl_wreq <= '0';
    dbram_wr_o <= '0';
    case wr_adr_d0(9 downto 9) is
    when "0" =>
      case wr_adr_d0(8 downto 2) is
      when "0000000" =>
        -- Reg version
        wr_ack_int <= wr_req_d0;
      when "0000001" =>
        -- Reg intid
        intid_wreq <= wr_req_d0;
        wr_ack_int <= intid_wack;
      when "0000010" =>
        -- Reg istat
        istat_wreq <= wr_req_d0;
        wr_ack_int <= istat_wack;
      when "0000011" =>
        -- Reg imask
        imask_wreq <= wr_req_d0;
        wr_ack_int <= imask_wack;
      when "0000100" =>
        -- Reg mstr
        mstr_wreq <= wr_req_d0;
        wr_ack_int <= mstr_wack;
      when "0000110" =>
        -- Reg sysc
        sysc_wreq <= wr_req_d0;
        wr_ack_int <= sysc_wack;
      when "0000111" =>
        -- Reg longadd
        longadd_wreq <= wr_req_d0;
        wr_ack_int <= longadd_wack;
      when "0001011" =>
        -- Reg dmasta
        dmasta_wreq <= wr_req_d0;
        wr_ack_int <= dmasta_wack;
      when "0010100" =>
        -- Reg slot
        wr_ack_int <= wr_req_d0;
      when "0010101" =>
        -- Reg brl
        brl_wreq <= wr_req_d0;
        wr_ack_int <= brl_wack;
      when "0010110" =>
        -- Reg berr_addr
        wr_ack_int <= wr_req_d0;
      when "0010111" =>
        -- Reg berr_extra
        wr_ack_int <= wr_req_d0;
      when others =>
        wr_ack_int <= wr_req_d0;
      end case;
    when "1" =>
      -- Submap dbram
      dbram_wr_o <= dbram_we;
      wr_ack_int <= dbram_we;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (wb_adr_i, rd_req_int, version_i, intid_val_reg, istat_acfail_reg,
           istat_irq_i, imask_acfail_reg, imask_irq_reg, mstr_rmwena_i,
           mstr_req_reg, mstr_berr_reg, mstr_iberr_reg, mstr_postwr_reg,
           mstr_ado_i, mstr_fairreq_reg, mstr_A16_mode_reg, mstr_A24_mode_reg,
           mstr_A32_mode_reg, sysc_sysc_i, sysc_sysr_i, sysc_ato_reg,
           longadd_val_reg, dmasta_en_i, dmasta_ien_reg, dmasta_irq_i,
           dmasta_err_i, dmasta_bd_i, slot_ga_i, slot_slot_i, brl_val_reg,
           berr_addr_i, berr_extra_vam_i, berr_extra_rw_i, berr_extra_iack_i,
           dbram_data_i, dbram_rack) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    dbram_re <= '0';
    case wb_adr_i(9 downto 9) is
    when "0" =>
      case wb_adr_i(8 downto 2) is
      when "0000000" =>
        -- Reg version
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0 <= version_i;
      when "0000001" =>
        -- Reg intid
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(7 downto 0) <= intid_val_reg;
        rd_dat_d0(31 downto 8) <= (others => '0');
      when "0000010" =>
        -- Reg istat
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(0) <= istat_acfail_reg;
        rd_dat_d0(7 downto 1) <= istat_irq_i;
        rd_dat_d0(31 downto 8) <= (others => '0');
      when "0000011" =>
        -- Reg imask
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(0) <= imask_acfail_reg;
        rd_dat_d0(7 downto 1) <= imask_irq_reg;
        rd_dat_d0(31 downto 8) <= (others => '0');
      when "0000100" =>
        -- Reg mstr
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(0) <= mstr_rmwena_i;
        rd_dat_d0(1) <= mstr_req_reg;
        rd_dat_d0(2) <= mstr_berr_reg;
        rd_dat_d0(3) <= mstr_iberr_reg;
        rd_dat_d0(4) <= mstr_postwr_reg;
        rd_dat_d0(5) <= mstr_ado_i;
        rd_dat_d0(6) <= mstr_fairreq_reg;
        rd_dat_d0(7) <= '0';
        rd_dat_d0(9 downto 8) <= mstr_A16_mode_reg;
        rd_dat_d0(11 downto 10) <= mstr_A24_mode_reg;
        rd_dat_d0(13 downto 12) <= mstr_A32_mode_reg;
        rd_dat_d0(31 downto 14) <= (others => '0');
      when "0000110" =>
        -- Reg sysc
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(0) <= sysc_sysc_i;
        rd_dat_d0(1) <= sysc_sysr_i;
        rd_dat_d0(2) <= sysc_ato_reg;
        rd_dat_d0(31 downto 3) <= (others => '0');
      when "0000111" =>
        -- Reg longadd
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(7 downto 0) <= longadd_val_reg;
        rd_dat_d0(31 downto 8) <= (others => '0');
      when "0001011" =>
        -- Reg dmasta
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(0) <= dmasta_en_i;
        rd_dat_d0(1) <= dmasta_ien_reg;
        rd_dat_d0(2) <= dmasta_irq_i;
        rd_dat_d0(3) <= dmasta_err_i;
        rd_dat_d0(7 downto 4) <= dmasta_bd_i;
        rd_dat_d0(31 downto 8) <= (others => '0');
      when "0010100" =>
        -- Reg slot
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(5 downto 0) <= slot_ga_i;
        rd_dat_d0(7 downto 6) <= (others => '0');
        rd_dat_d0(12 downto 8) <= slot_slot_i;
        rd_dat_d0(31 downto 13) <= (others => '0');
      when "0010101" =>
        -- Reg brl
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(1 downto 0) <= brl_val_reg;
        rd_dat_d0(31 downto 2) <= (others => '0');
      when "0010110" =>
        -- Reg berr_addr
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0 <= berr_addr_i;
      when "0010111" =>
        -- Reg berr_extra
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0(5 downto 0) <= berr_extra_vam_i;
        rd_dat_d0(6) <= berr_extra_rw_i;
        rd_dat_d0(7) <= berr_extra_iack_i;
        rd_dat_d0(31 downto 8) <= (others => '0');
      when others =>
        rd_ack_d0 <= rd_req_int;
      end case;
    when "1" =>
      -- Submap dbram
      rd_dat_d0 <= dbram_data_i;
      rd_ack_d0 <= dbram_rack;
      dbram_re <= rd_req_int;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
